Subject: Re: [Jmap] Fwd: New Version Notification for draft-baum-jmap-tasks-00.txt

From: "Neil Jenkins" <[email-masked]>
Date: Thu, 11 Mar 2021 14:37:09 +1100

Thanks Joris! This is a great start, and reading through it I have a few thoughts for discussion at the imminent IETF 110 JMAP session and on the mailing list.

The biggest question is definitely whether we should merge this into the JMAP Calendars spec; copy pasting so much stuff is generally pretty unwieldy. I think it's still important that servers can choose to support one and no the other, but we can easily define multiple capabilities in the same spec. On the other hand, now sharing is split out we might be able to do most things by reference and not be too duplicative, in which case I still think separate specs is slightly cleaner.

Some other thoughts:
 * Many todo lists are a (manually) ordered series of tasks. I think supporting this is important; the way we generally do it in JMAP is to add a `sortOrder` property to the `Task` object (like we already have on the `TaskList` object).
 * Does it make sense for a `Task` to belong to multiple `TaskList`s? This interacts with the previous point; we would probably need to store a different sort order for each list it's in, which starts to get very unwieldy. Are there any existing task managers that do this, or is a task always in one list?
 * I'm not sure the `isVisible` property (copied over from Calendar) makes sense for TaskList.
 * The computed UTC properties for a Task need to be updated to map to task rather than event properties (e.g. `utcDue` for the due date).
Cheers,
Neil.